//+------------------------------------------------------------------+
//|                                           Volatility quality.mq4 |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  DeepSkyBlue
#property indicator_color4  PaleVioletRed
#property indicator_color5  DeepSkyBlue
#property indicator_color6  PaleVioletRed
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern string TimeFrame            = "Current time frame";
extern int    PriceSmoothing       = 15;
extern int    PriceSmoothingMethod = MODE_LWMA;
extern double Filter               = 5;
extern bool   HistogramOnSlope     = false;

extern string _                    = "alerts settings";
extern bool   alertsOn             = true;
extern bool   alertsOnSlope        = true;
extern bool   alertsOnCurrent      = true;
extern bool   alertsMessage        = true;
extern bool   alertsSound          = false;
extern bool   alertsEmail          = false;

//
//
//
//
//

double vqhu[];
double vqhd[];
double vqhbu[];
double vqhbd[];
double vqhcu[];
double vqhcd[];
double SumVq[];
double Vqi[];
double trend[];
double slope[];

//
//
//
//                    
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,vqhu);  SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,vqhd);  SetIndexStyle(1,DRAW_HISTOGRAM);  
      SetIndexBuffer(2,vqhbu); SetIndexStyle(2,DRAW_HISTOGRAM); 
      SetIndexBuffer(3,vqhbd); SetIndexStyle(3,DRAW_HISTOGRAM); 
      SetIndexBuffer(4,vqhcu); SetIndexStyle(4,DRAW_HISTOGRAM); 
      SetIndexBuffer(5,vqhcd); SetIndexStyle(5,DRAW_HISTOGRAM); 
      SetIndexBuffer(6,SumVq);
      SetIndexBuffer(7,Vqi);   
      
      SetIndexEmptyValue(6,0.0);
      Filter            = MathMax(Filter,0); 
      PriceSmoothing    = MathMax(PriceSmoothing,1);  
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //         
     
   IndicatorShortName(timeFrameToString(timeFrame)+"  VQ candles ("+PriceSmoothing+")");
   return(0);
}
int deinit() { return(0);}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars <0)  return(-1);
   if(counted_bars >0)  counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { vqhu[0] = limit+1; return(0); }
           
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
      if (ArrayRange(trend,0)!=Bars) ArrayResize(trend,Bars);
      if (ArrayRange(slope,0)!=Bars) ArrayResize(slope,Bars);   
      for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      { 
         if (i==(Bars-1))
         {
            Vqi[i]   = 0;
            SumVq[i] = 0;
            continue;
         }
      
         //
         //
         //
         //
         //
         
         double cHigh  = iMA(NULL,0,PriceSmoothing,0,PriceSmoothingMethod,PRICE_HIGH ,i);
         double cLow   = iMA(NULL,0,PriceSmoothing,0,PriceSmoothingMethod,PRICE_LOW  ,i);
         double cOpen  = iMA(NULL,0,PriceSmoothing,0,PriceSmoothingMethod,PRICE_OPEN ,i);
         double cClose = iMA(NULL,0,PriceSmoothing,0,PriceSmoothingMethod,PRICE_CLOSE,i);
         double pClose = iMA(NULL,0,PriceSmoothing,0,PriceSmoothingMethod,PRICE_CLOSE,i+1);

         double trueRange = MathMax(cHigh,pClose)-MathMin(cLow,pClose);
         double     range = cHigh-cLow;
      
            if (range != 0 && trueRange!=0)
               double vqi = ((cClose-pClose)/trueRange + (cClose-cOpen)/range)*0.5;
            else      vqi = Vqi[i+1];

      //
      //
      //
      //
      //
         
         Vqi[i]   = MathAbs(vqi) * (cClose - pClose+cClose - cOpen) * 0.5;
         SumVq[i] = Vqi[i];
         if (Filter > 0) if (MathAbs(SumVq[i] - SumVq[i+1]) < Filter * Point) SumVq[i] = SumVq[i+1];
         
         //
         //
         //
         //
         //

         trend[r]  = trend[r-1];
         slope[r]  = slope[r-1];
            if (SumVq[i] > 0)          trend[r] =  1;
            if (SumVq[i] < 0)          trend[r] = -1;
            if (SumVq[i] > SumVq[i+1]) slope[r] =  1;
            if (SumVq[i] < SumVq[i+1]) slope[r] = -1;
            
            if (HistogramOnSlope)
            {
              if (trend[r]== 1 && slope[r]== 1)
              {
                vqhu[i]  = High[i]; 
                vqhd[i]  = Low[i];
                vqhbu[i] = MathMax(Open[i],Close[i]);
                vqhbd[i] = MathMin(Open[i],Close[i]);
              }
              if (trend[r]== 1 && slope[r]== -1)
              {
                vqhu[i]  = High[i]; 
                vqhd[i]  = Low[i];
                vqhcu[i] = MathMax(Open[i],Close[i]);
                vqhcd[i] = MathMin(Open[i],Close[i]);
              }                              
              if (trend[r]== -1 && slope[r]== -1)
              {
                vqhu[i]  = Low[i];
                vqhd[i]  = High[i];
                vqhbu[i] = MathMin(Open[i],Close[i]);
                vqhbd[i] = MathMax(Open[i],Close[i]);
              }
              if (trend[r]== -1 && slope[r]== 1)
              {
                vqhu[i]  = Low[i];
                vqhd[i]  = High[i];
                vqhcu[i] = MathMin(Open[i],Close[i]);
                vqhcd[i] = MathMax(Open[i],Close[i]);
              }
            }
            else
            {
              if (trend[r]== 1)
              {
                vqhu[i]  = High[i]; 
                vqhd[i]  = Low[i];
                vqhbu[i] = MathMax(Open[i],Close[i]);
                vqhbd[i] = MathMin(Open[i],Close[i]);
              }               
              if (trend[r]==-1)
              {
                vqhu[i]  = Low[i];
                vqhd[i]  = High[i];
                vqhbu[i] = MathMin(Open[i],Close[i]);
                vqhbd[i] = MathMax(Open[i],Close[i]);
              }  
            }             
      }
      manageAlerts();
      return(0);
      }
      
      //
      //
      //
      //
      //
      
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      if (ArrayRange(trend,0)!=Bars) ArrayResize(trend,Bars);
      if (ArrayRange(slope,0)!=Bars) ArrayResize(slope,Bars);   
      for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
            SumVq[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PriceSmoothing,PriceSmoothingMethod,Filter,6,y);
            vqhu[i]  = EMPTY_VALUE;
            vqhd[i]  = EMPTY_VALUE;
            vqhbu[i] = EMPTY_VALUE;
            vqhbd[i] = EMPTY_VALUE;
            vqhcu[i] = EMPTY_VALUE;
            vqhcd[i] = EMPTY_VALUE;
            trend[r] = trend[r-1];
            slope[r] = slope[r-1];
            if (SumVq[i] > 0)          trend[r] =  1;
            if (SumVq[i] < 0)          trend[r] = -1;
            if (SumVq[i] > SumVq[i+1]) slope[r] =  1;
            if (SumVq[i] < SumVq[i+1]) slope[r] = -1;
       
            if (HistogramOnSlope)
            {
              if (trend[r]== 1 && slope[r]== 1)
              {
                vqhu[i]  = High[i]; 
                vqhd[i]  = Low[i];
                vqhbu[i] = MathMax(Open[i],Close[i]);
                vqhbd[i] = MathMin(Open[i],Close[i]);
              }
              if (trend[r]== 1 && slope[r]== -1)
              {
                vqhu[i]  = High[i]; 
                vqhd[i]  = Low[i];
                vqhcu[i] = MathMax(Open[i],Close[i]);
                vqhcd[i] = MathMin(Open[i],Close[i]);
              }                              
              if (trend[r]== -1 && slope[r]== -1)
              {
                vqhu[i]  = Low[i];
                vqhd[i]  = High[i];
                vqhbu[i] = MathMin(Open[i],Close[i]);
                vqhbd[i] = MathMax(Open[i],Close[i]);
              }
              if (trend[r]== -1 && slope[r]== 1)
              {
                vqhu[i]  = Low[i];
                vqhd[i]  = High[i];
                vqhcu[i] = MathMin(Open[i],Close[i]);
                vqhcd[i] = MathMax(Open[i],Close[i]);
              }
            }
            else
            {
              if (trend[r]== 1)
              {
                vqhu[i]  = High[i]; 
                vqhd[i]  = Low[i];
                vqhbu[i] = MathMax(Open[i],Close[i]);
                vqhbd[i] = MathMin(Open[i],Close[i]);
              }               
              if (trend[r]==-1)
              {
                vqhu[i]  = Low[i];
                vqhd[i]  = High[i];
                vqhbu[i] = MathMin(Open[i],Close[i]);
                vqhbd[i] = MathMax(Open[i],Close[i]);
              }  
            }
    }
manageAlerts();
return(0);
}             

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}     

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = Bars-iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar))-1;
      
      //
      //
      //
      //
      //
      
      if (alertsOnSlope)
      {
         if (slope[whichBar] != slope[whichBar-1])
         {
            if (slope[whichBar] == 1) doAlert(whichBar,"slope changed to up");
            if (slope[whichBar] ==-1) doAlert(whichBar,"slope changed to down");
         }         
      }
      else
      {
         if (trend[whichBar] != trend[whichBar-1])
         {
            if (trend[whichBar] == 1) doAlert(whichBar,"crossed zero line up");
            if (trend[whichBar] ==-1) doAlert(whichBar,"crossed zero line down");
         }         
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrame," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," VQ candles ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," VQ candles "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}